local mod = ...


-- Job -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "VEGETABLEFARMER_JOB",
	JobName = "VEGETABLEFARMER_JOB_NAME",
	JobDescription = "VEGETABLEFARMER_JOB_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 70.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        FemaleHatList = {
            "PREFAB_HAT_FARMER3",
        }, 
        MaleHatList = {
            "PREFAB_HAT_FARMER3",
        }, 
		-- RightHandObject = {
		-- 	DataType = "HAND_OBJECT",
		-- 	Model = "PREFAB_TOOL_COAL_BURNER_SHOVEL"
			-- Model = "PREFAB_TOOL_STONECUTTER_PICKAXE"
		-- },
		IdleAnimation = "FORESTER"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "VEGETABLEFARMER_JOB"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "VEGETABLEFARMER_JOB"
    }
})



-- Resource Type: Vegetable Farm
mod:registerEnumValue( "RESOURCE_TYPE", "VEGETABLEFARM_RESOURCE_TYPE" )



-- Resource -------------------------------------------------------------------------------------

mod:registerAssetId("icons/Vegetable.png", "ICON_VEGETABLE")

mod:register({
	DataType = "RESOURCE",
	Id = "VEGETABLE_RESOURCE",
	ResourceName = "VEGETABLE_RESOURCE_NAME",
	OrderId = 5,
	Icon = "ICON_VEGETABLE",
	ResourceTypeList = { "FOOD", "VEGETABLEFARM_RESOURCE_TYPE" },
	IsTradable = true,
	ResourceLayoutType = "CRATES",
	VillagerBuyingPrice = { Resource = "GOLD", Quantity = 12 },
	DisplayInInventory = true
})



-- Building part type
mod:registerEnumValue("BUILDING_PART_TYPE", "COUNTER")



-- Assets
mod:registerAssetId("models/VegetablePatch2.fbx/Prefab/ConstructionSteps/Step_0.001", "PREFAB_POST")

mod:registerAssetId("models/VegetablePatch2.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH2")
mod:registerAssetId("models/VegetablePatch2f.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH2F")
mod:registerAssetId("models/VegetablePatch2n.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH2N")
mod:registerAssetId("models/VegetablePatch2nf.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH2NF")

mod:registerAssetId("models/VegetablePatch4.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH4")
mod:registerAssetId("models/VegetablePatch4f.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH4F")
mod:registerAssetId("models/VegetablePatch4n.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH4N")
mod:registerAssetId("models/VegetablePatch4nf.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH4NF")

mod:registerAssetId("models/VegetablePatch6.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH6")
mod:registerAssetId("models/VegetablePatch6n.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH6N")
mod:registerAssetId("models/VegetablePatch6f.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH6F")
mod:registerAssetId("models/VegetablePatch6nf.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH6NF")

mod:registerAssetId("models/VegetablePatch9.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH8")
mod:registerAssetId("models/VegetablePatch9f.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH8F")
mod:registerAssetId("models/VegetablePatch9n.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH8N")
mod:registerAssetId("models/VegetablePatch9nf.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH8NF")

mod:registerAssetId("models/VegetablePatch10.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH10")
mod:registerAssetId("models/VegetablePatch10f.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH10F")
mod:registerAssetId("models/VegetablePatch10n.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH10N")
mod:registerAssetId("models/VegetablePatch10nf.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH10NF")

mod:registerAssetId("models/VegetablePatch12.fbx/Prefab/VegetablePatchPart", "PREFAB_VEGETABLEPATCH12")

mod:registerAssetId("models/VegetableCart.fbx/Prefab/CartPart", "PREFAB_VEGETABLECART")



-- Building Asset Processor
mod:registerAssetProcessor("models/VegetablePatch2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch2f.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch2n.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch2nf.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })

mod:registerAssetProcessor("models/VegetablePatch4.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch4n.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch4f.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch4nf.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })

mod:registerAssetProcessor("models/VegetablePatch6.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch6f.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch6n.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch6nf.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })

mod:registerAssetProcessor("models/VegetablePatch9.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch9f.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch9n.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch9nf.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })

mod:registerAssetProcessor("models/VegetablePatch10.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch10n.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch10f.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/VegetablePatch10nf.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })

mod:registerAssetProcessor("models/VegetablePatch12.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })

mod:registerAssetProcessor("models/VegetableCart.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Construction visual
mod:registerAssetId("models/VegetablePatch2.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH2")
mod:registerAssetId("models/VegetablePatch2f.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH2F")
mod:registerAssetId("models/VegetablePatch2n.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH2N")
mod:registerAssetId("models/VegetablePatch2nf.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH2NF")

mod:registerAssetId("models/VegetablePatch4.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH4")
mod:registerAssetId("models/VegetablePatch4n.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH4N")
mod:registerAssetId("models/VegetablePatch4f.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH4F")
mod:registerAssetId("models/VegetablePatch4nf.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH4NF")

mod:registerAssetId("models/VegetablePatch6.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH6")
mod:registerAssetId("models/VegetablePatch6f.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH6F")
mod:registerAssetId("models/VegetablePatch6n.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH6N")
mod:registerAssetId("models/VegetablePatch6nf.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH6NF")

mod:registerAssetId("models/VegetablePatch9.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH8")
mod:registerAssetId("models/VegetablePatch9f.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH8F")
mod:registerAssetId("models/VegetablePatch9n.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH8N")
mod:registerAssetId("models/VegetablePatch9nf.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH8NF")

mod:registerAssetId("models/VegetablePatch10.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH10")
mod:registerAssetId("models/VegetablePatch10n.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH10N")
mod:registerAssetId("models/VegetablePatch10f.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH10F")
mod:registerAssetId("models/VegetablePatch10nf.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH10NF")

mod:registerAssetId("models/VegetablePatch12.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_VEGETABLEPATCH12")



-- Grounding construction visuals
for i=1, 5, 1 do
	mod:registerPrefabComponent("models/VegetablePatch2.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch2f.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch4.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch4f.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch6.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch6f.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch9f.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch10.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch10f.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch10nf.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 6, 1 do
	mod:registerPrefabComponent("models/VegetablePatch2n.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch2nf.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch4n.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch4nf.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch6n.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch6nf.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch9.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch9n.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch9nf.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch10n.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 7, 1 do
	mod:registerPrefabComponent("models/VegetablePatch12.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 9, 1 do
	mod:registerPrefabComponent("models/VegetablePatch10n.fbx/Prefab/ConstructionSteps/Step_1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 10, 1 do
	mod:registerPrefabComponent("models/VegetablePatch2n.fbx/Prefab/ConstructionSteps/Step_1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch4n.fbx/Prefab/ConstructionSteps/Step_1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch6n.fbx/Prefab/ConstructionSteps/Step_1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch9n.fbx/Prefab/ConstructionSteps/Step_1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 11, 1 do
	mod:registerPrefabComponent("models/VegetablePatch2.fbx/Prefab/ConstructionSteps/Step_1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch4.fbx/Prefab/ConstructionSteps/Step_1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch6.fbx/Prefab/ConstructionSteps/Step_1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch9.fbx/Prefab/ConstructionSteps/Step_1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch10.fbx/Prefab/ConstructionSteps/Step_1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 15, 1 do
	mod:registerPrefabComponent("models/VegetablePatch12.fbx/Prefab/ConstructionSteps/Step_1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end



-- Grounding fences
for i=1, 9, 1 do
	mod:registerPrefabComponent("models/VegetablePatch10n.fbx/Prefab/VegetablePatchPart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 10, 1 do
	mod:registerPrefabComponent("models/VegetablePatch2n.fbx/Prefab/VegetablePatchPart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch4n.fbx/Prefab/VegetablePatchPart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch6n.fbx/Prefab/VegetablePatchPart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch9n.fbx/Prefab/VegetablePatchPart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 11, 1 do
	mod:registerPrefabComponent("models/VegetablePatch2.fbx/Prefab/VegetablePatchPart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch4.fbx/Prefab/VegetablePatchPart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch6.fbx/Prefab/VegetablePatchPart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch9.fbx/Prefab/VegetablePatchPart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch10.fbx/Prefab/VegetablePatchPart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 15, 1 do
	mod:registerPrefabComponent("models/VegetablePatch12.fbx/Prefab/VegetablePatchPart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end



-- Grounding plants
for i=1, 2, 1 do
	mod:registerPrefabComponent("models/VegetablePatch6.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 15, 1 do
	mod:registerPrefabComponent("models/VegetablePatch4n.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch4nf.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 18, 1 do
	mod:registerPrefabComponent("models/VegetablePatch9n.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch9nf.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 24, 1 do
	mod:registerPrefabComponent("models/VegetablePatch9.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 25, 1 do
	mod:registerPrefabComponent("models/VegetablePatch4.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch4f.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 27, 1 do
	mod:registerPrefabComponent("models/VegetablePatch2n.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch2nf.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 30, 1 do
	mod:registerPrefabComponent("models/VegetablePatch10n.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch10nf.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch9f.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 36, 1 do
	mod:registerPrefabComponent("models/VegetablePatch10.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch10f.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 45, 1 do
	mod:registerPrefabComponent("models/VegetablePatch2.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/VegetablePatch2f.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 57, 1 do
	mod:registerPrefabComponent("models/VegetablePatch12.fbx/Prefab/VegetablePatchPart/Plant." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end



-- Grounding general
mod:registerPrefabComponent("models/VegetableCart.fbx/Prefab/CartPart", {DataType = "COMP_GROUNDED"})



-- Building Function: Vegetable field -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "VEGETABLEPATCH_FUNCTION",
    Name = "VEGETABLEPATCH_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "VEGETABLEFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "WATER", Quantity = 5 },
		{ Resource = "COMPOST_RESOURCE", Quantity = 5 }
	},
    ResourceListNeeded = {
		{ Resource = "WATER", Quantity = 1 },
		{ Resource = "COMPOST_RESOURCE", Quantity = 1 },
	},
	ResourceProduced = {{ Resource = "VEGETABLE_RESOURCE", Quantity = 1 }}

})



-- Building Function: Vegetable Cart (sell directly to villagers) -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "VEGETABLECART_FUNCTION",
    Name = "VEGETABLECART_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "VEGETABLEFARM_RESOURCE_TYPE" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 50,
	InputInventoryCapacity = {
		{ Resource = "VEGETABLE_RESOURCE", Quantity = 25 },
	},
    ResourceListNeeded = {
		{ Resource = "VEGETABLE_RESOURCE", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "VEGETABLE_RESOURCE", Quantity = 10 },
	}
})



-- Building -------------------------------------------------------------------------------------

mod:register({
	DataType = "BUILDING", 
	Id = "VEGETABLEFARM",
	Name = "VEGETABLEFARM_NAME",
	Description = "VEGETABLEFARM_DESC",
	BuildingType = "GENERAL",
	AssetCoreBuildingPart = "POST_PART",
	BuildingPartSetList = {
        {
            Name = "BUILDING_PART_SET_VEGETABLE_FARM1",
            BuildingPartList = { 
                "BUILDING_PART_VEGETABLE_FARM1",
				"BUILDING_PART_VEGETABLE_SHED1",
            }
        },
		{
			Name = "VEGETABLEPATCH_SET1_NAME",
			BuildingPartList = { 
				"VEGETABLEPATCH2_PART",
				"VEGETABLEPATCH4_PART",
				"VEGETABLEPATCH8_PART",
				"VEGETABLEPATCH6_PART",
				"VEGETABLEPATCH10_PART",
				"VEGETABLEPATCH12_PART",
			}
		},
		{
			Name = "VEGETABLEPATCH_SET2_NAME",
			BuildingPartList = { 
				"VEGETABLEPATCH2N_PART",
				"VEGETABLEPATCH4N_PART",
				"VEGETABLEPATCH8N_PART",
				"VEGETABLEPATCH6N_PART",
				"VEGETABLEPATCH10N_PART",
			}
		},
		{
			Name = "VEGETABLEPATCH_SET3_NAME",
			BuildingPartList = { 
				"VEGETABLEPATCH2F_PART",
				"VEGETABLEPATCH4F_PART",
				"VEGETABLEPATCH8F_PART",
				"VEGETABLEPATCH6F_PART",
				"VEGETABLEPATCH10F_PART",
			}
		},
		{
			Name = "VEGETABLEPATCH_SET4_NAME",
			BuildingPartList = { 
				"VEGETABLEPATCH2NF_PART",
				"VEGETABLEPATCH4NF_PART",
				"VEGETABLEPATCH8NF_PART",
				"VEGETABLEPATCH6NF_PART",
				"VEGETABLEPATCH10NF_PART",
			}
		},
		{
			Name = "VEGETABLEPATCH_SET5_NAME",
			BuildingPartList = { 
				"VEGETABLECART_PART",
			}
		},
	},	
	RequiredPartList = {
		{ Category = "CORE", Quantity = 1 }
	},
	IsEditable = true
})


-- Building Part: Post -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "POST_PART",
	Name = "POST_PART_NAME", 
	Description = "VEGETABLEFARM_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_POST"
	},
	IsVisibleWhenBuilt = false
})



-- Building Part: Vegetable Patch 2 (beet field with fence) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH2_PART",
	Name = "VEGETABLEPATCH2_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH2"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH2",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {9, 9}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 2n (narrow beet field with fence) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH2N_PART",
	Name = "VEGETABLEPATCH2N_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH2N"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH2N",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {6.5, 9}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})


-- Building Part: Vegetable Patch 2f (beet field) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH2F_PART",
	Name = "VEGETABLEPATCH2F_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH2F"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH2F",
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {7.0, 7.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 2NF (narrow beet field) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH2NF_PART",
	Name = "VEGETABLEPATCH2NF_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH2NF"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH2NF",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.0, 7.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})


-- Building Part: Vegetable Patch 4 (cabbage field with fence) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH4_PART",
	Name = "VEGETABLEPATCH4_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH4"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH4",
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {9, 9}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 4n (narrow cabbage field with fence) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH4N_PART",
	Name = "VEGETABLEPATCH4N_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH4N"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH4N",
	BuildingZone = { 
        ZoneEntryList = {
            { 
				Polygon = polygon.createRectangle( {6.5, 9}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 4f (cabbage field) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH4F_PART",
	Name = "VEGETABLEPATCH4F_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH4F"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH4F",
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {7.0, 7.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 4nf (narrow cabbage field) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH4NF_PART",
	Name = "VEGETABLEPATCH4NF_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH4NF"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH4NF",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.0, 7.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 6 (fallow field with fence) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH6_PART",
	Name = "VEGETABLEPATCH6_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH6"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH6",
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {9, 9}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 6n (narrow fallow field with fence) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH6N_PART",
	Name = "VEGETABLEPATCH6N_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH6N"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH6N",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {6.5, 9}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 6F (fallow field) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH6F_PART",
	Name = "VEGETABLEPATCH6F_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH6F"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH6F",
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {7.0, 7.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 6nf (narrow fallow field) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH6NF_PART",
	Name = "VEGETABLEPATCH6NF_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH6NF"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH6NF",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.0, 7.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 8 (bean field with fence) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH8_PART",
	Name = "VEGETABLEPATCH8_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH8"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH8",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {9, 9}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 8n (narrow bean field with fence) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH8N_PART",
	Name = "VEGETABLEPATCH8N_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH8N"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH8N",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {6.5, 9}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 8F (bean field) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH8F_PART",
	Name = "VEGETABLEPATCH8F_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH8F"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH8F",
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {7.0, 7.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 8NF (narrow bean field) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH8NF_PART",
	Name = "VEGETABLEPATCH8NF_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH8NF"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH8NF",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.0, 7.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 10 (broccoli field with fence) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH10_PART",
	Name = "VEGETABLEPATCH10_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH10"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH10",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {9, 9}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 10n (narrow broccoli field with fence) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH10N_PART",
	Name = "VEGETABLEPATCH10N_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH10N"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH10N",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {9, 6}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 10F (broccoli field) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH10F_PART",
	Name = "VEGETABLEPATCH10F_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH10F"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH10F",
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {7.0, 7.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 10NF (narrow broccoli field) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH10NF_PART",
	Name = "VEGETABLEPATCH10NF_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH10NF"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH10NF",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {7.0, 4.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Patch 12 (large mixed garden) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLEPATCH12_PART",
	Name = "VEGETABLEPATCH12_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLEPATCH12"
	},
	ConstructionVisual = "PREFAB_CONSTR_VEGETABLEPATCH12",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {15, 9}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLEPATCH_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 10 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})



-- Building Part: Vegetable Cart -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "VEGETABLECART_PART",
	Name = "VEGETABLECART_PART_NAME", 
	Category = "COUNTER",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_VEGETABLECART"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_BUTCHERCOUNTER",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 1.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "VEGETABLECART_FUNCTION",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 1 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 }
		}
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "ADD",
		Radius = 15.0,
		Value = 0.5
	} }
})
